#!/usr/bin/env python

divine = "divine"

import os
import sys

def benchmark_functions():
    lengths = [ 10, 50, 100, 1000 ]
    flavours = [ "VALUE", "LOOP", "WRONG" ]

    for flavour in flavours:
        for length in lengths:
            print( "--- FLALOUR {} LENGTH {} ---".format( flavour, length ) )
            os.environ['F'] = flavour
            os.environ['L'] = str(length)
            os.system("make")
            sys.stdout.flush()
            benchmark( "simple", length, flavour )

def benchmark( name, length, flavour ):
    params = [ divine, "check", "--lart abstraction:mstring:explicit", "--symbolic", "--sequential" ]
    params.append( "-o ignore:control" )
    params.append( "--max-memory 80G" )
    params.append( "--threads 4" )
    params.append( "--max-time 3600" )
    params.append( "-o ignore:memory" )
    params.append( "-C,-D{}".format( flavour ) )
    params.append( "-C,-DLENGTH={}".format( length ) )
    params.append( "--report-filename {}".format( name + "-" + flavour + "-" + str(length) + ".report" ) )
    params.append( "parser.bc" )
    os.system( ' '.join(params) )

if __name__ == "__main__":
    benchmark_functions()
