#include <stdio.h>
#include <string.h>
#include <stdbool.h>

#include <dios.h>
#include <rst/domains.h>

extern bool scan_buffer( char * buff, size_t len );

extern int yylex( void );
extern int yyparse( void );

#ifdef VALUE
static inline char * program( int size ) {
    return __mstring_sym_val( 2, '+', 1, size, '\0', size + 2, size + 3 );
}
#endif

#ifdef LOOP
static inline char * program( int size ) {
    return __mstring_sym_val( 5,
        '[', 1, 2,
        '+', 2, size - 1,
        '-', size, size + 1,
        ']', size + 1, size + 2,
        '\0', size + 4, size + 5 );
}
#endif

#ifdef WRONG
static inline char * program( int size ) {
    return __mstring_sym_val( 5,
        '*', 1, 2,
        '+', 2, size - 1,
        '-', size, size + 1,
        ']', size + 1, size + 2,
        '\0', size + 4, size + 5 );
}
#endif

void emit( const char * s ) {
    puts( s );
}

int main() {
    char * e = program( LENGTH );
    assert( scan_buffer( e, strlen( e ) + 2 ) );
    yylex();
    free( e );
}

