%option nostdinit noyywrap never-interactive full ecs

%{

#include "parser.h"

#include <stdio.h>
#include <assert.h>
#include <stdbool.h>

#undef YY_INPUT
#define YY_INPUT( buf, result, max_size ) \
    result = YY_NULL

%}

%%

"<"  { return INSTR_LEFT; }
">"  { return INSTR_RIGHT; }
"+"  { return INSTR_INCR; }
"-"  { return INSTR_DECR; }
"."  { return INSTR_PRINT; }
","  { return INSTR_READ; }
"["  { return LOOP_START; }
"]"  { return LOOP_END; }
[ \t\n\r] /* nothing */
.    { printf( "parsing error" ); }

%%


void yyerror( char * s )
{
    printf( "nope: %s\n", s );
}

bool scan_buffer( char * base, size_t size )
{
    return yy_scan_buffer( base, size );
}
