%{

extern void yyerror( char * s );
extern int yylex();
extern void emit( const char * s );

%}

%token INSTR_LEFT   '<'
%token INSTR_RIGHT  '>'
%token INSTR_INCR   '+'
%token INSTR_DECR   '-'
%token INSTR_PRINT  '.'
%token INSTR_READ   ','
%token LOOP_START   '['
%token LOOP_END     ']'

%%

brainfuck: statement
         | statement brainfuck
         ;

statement: instruction
         | LOOP_START { emit( "while ( *ptr ) {" ); } brainfuck LOOP_END { emit( "}" ); }
         ;

instruction: INSTR_LEFT     { emit( "++p;" ); }
           | INSTR_RIGHT    { emit( "--p;" ); }
           | INSTR_INCR     { emit( "++*p;" ); }
           | INSTR_DECR     { emit( "--*p;" ); }
           | INSTR_PRINT    { emit( "putchar( *p );" ); }
           | INSTR_READ     { emit( "*ptr = getchar();" ); }
           ;

%%
